scala
object Predef

[source: `scala/Predef.scala`]

`` `object` Predef
  `extends` AnyRef

  The `Predef` object provides definitions that are accessible in all Scala compilation units without explicit qualification.

Type Summary
`type` | All
`type` | AllRef
`type` | ArrayIndexOutOfBoundsException
`type` | Character
`type` | Class
`type` | ClassCastException
`type` | Error
`type` | Exception
`type` | Function
`type` | IllegalArgumentException
`type` | IndexOutOfBoundsException
`type` | Integer
`type` | Map
`type` | NoSuchElementException
`type` | NullPointerException
`type` | NumberFormatException
`type` | Pair
`type` | Runnable
`type` | RuntimeException
`type` | Set
`type` | String
`type` | StringBuilder
`type` | Throwable
`type` | Triple
`type` | UnsupportedOperationException
`type` | boolean
`type` | byte
`type` | char
`type` | double
`type` | float
`type` | int
`type` | long
`type` | short
`type` | unit

Value Summary
`val` | Map : Map
`val` | Set : Set

Method Summary
`def` | Tuple [A1, A2, A3](x1 : A1, x2 : A2, x3 : A3) : (A1, A2, A3)
`def` | Tuple [A1, A2, A3, A4](x1 : A1, x2 : A2, x3 : A3, x4 : A4) : (A1, A2, A3, A4)
`def` | Tuple [A1, A2, A3, A4, A5, A6, A7, A8](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7, x8 : A8) : (A1, A2, A3, A4, A5, A6, A7, A8)
`def` | Tuple [A1, A2, A3, A4, A5, A6](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6) : (A1, A2, A3, A4, A5, A6)
`def` | Tuple [A1, A2, A3, A4, A5, A6, A7](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7) : (A1, A2, A3, A4, A5, A6, A7)
`def` | Tuple [A1, A2](x1 : A1, x2 : A2) : (A1, A2)
`def` | Tuple [A1, A2, A3, A4, A5, A6, A7, A8, A9](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7, x8 : A8, x9 : A9) : (A1, A2, A3, A4, A5, A6, A7, A8, A9)
`def` | Tuple [A1](x1 : A1) : (A1)
`def` | Tuple [A1, A2, A3, A4, A5](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5) : (A1, A2, A3, A4, A5)
`implicit def` | any2ArrowAssoc [A](x : A) : ArrowAssoc[A]
`implicit def` | any2stringadd (x : Any) : StringAdd
`def` | assert (assertion : Boolean, message : Any) : Unit
`def` | assert (assertion : Boolean) : Unit
`def` | assume (assumption : Boolean, message : Any) : Unit
`def` | assume (assumption : Boolean) : Unit
`implicit def` | boolean2Boolean (x : Boolean) : java.lang.Boolean
`implicit def` | booleanWrapper (x : Boolean) : RichBoolean
`implicit def` | byte2Byte (x : Byte) : java.lang.Byte
`implicit def` | byte2double (x : Byte) : Double
`implicit def` | byte2float (x : Byte) : Float
`implicit def` | byte2int (x : Byte) : Int
`implicit def` | byte2long (x : Byte) : Long
`implicit def` | byte2short (x : Byte) : Short
`implicit def` | byteWrapper (x : Byte) : RichByte
`implicit def` | char2Character (x : Char) : java.lang.Character
`implicit def` | char2double (x : Char) : Double
`implicit def` | char2float (x : Char) : Float
`implicit def` | char2int (x : Char) : Int
`implicit def` | char2long (x : Char) : Long
`implicit def` | charWrapper (c : Char) : RichChar
`def` | classOf [T] : java.lang.Class Return the runtime representation of a class type.
`def` | currentThread : java.lang.Thread
`implicit def` | double2Double (x : Double) : java.lang.Double
`implicit def` | doubleWrapper (x : Double) : RichDouble
`def` | error (message : java.lang.String) : Nothing
`implicit def` | exceptionWrapper (exc : java.lang.Throwable) : RichException
`def` | exit : Nothing
`def` | exit (status : Int) : Nothing
`implicit def` | float2Float (x : Float) : java.lang.Float
`implicit def` | float2double (x : Float) : Double
`implicit def` | floatWrapper (x : Float) : RichFloat
`implicit def` | forceArrayProjection [A](x : Projection[A]) : Array[A] any array projection can be automatically converted into an array
`implicit def` | forceRandomAccessCharSeq (x : RichString) : java.lang.String any random access character seq (including rich string can be converted into a string
`def` | format (text : java.lang.String, xs : Any*) : Unit
`implicit def` | identity [A](x : A) : A
`implicit def` | int2Integer (x : Int) : java.lang.Integer
`implicit def` | int2double (x : Int) : Double
`implicit def` | int2float (x : Int) : Float
`implicit def` | int2long (x : Int) : Long
`implicit def` | intWrapper (x : Int) : RichInt
`implicit def` | iterable2ordered [A](xs : Iterable[A])(`implicit` view$1 : (A) => Ordered[A]) : Ordered[Iterable[A]]
`implicit def` | long2Long (x : Long) : java.lang.Long
`implicit def` | long2double (x : Long) : Double
`implicit def` | long2float (x : Long) : Float
`implicit def` | longWrapper (x : Long) : RichLong
`def` | print (x : Any) : Unit
`def` | printf (text : java.lang.String, xs : Any*) : Unit
`def` | println : Unit
`def` | println (x : Any) : Unit
`def` | readBoolean : Boolean
`def` | readByte : Byte
`def` | readChar : Char
`def` | readDouble : Double
`def` | readFloat : Float
`def` | readInt : Int
`def` | readLine (text : java.lang.String, args : Any*) : java.lang.String
`def` | readLine : java.lang.String
`def` | readLong : Long
`def` | readShort : Short
`def` | readf (format : java.lang.String) : List[Any]
`def` | readf1 (format : java.lang.String) : Any
`def` | readf2 (format : java.lang.String) : (Any, Any)
`def` | readf3 (format : java.lang.String) : (Any, Any, Any)
`implicit def` | short2Short (x : Short) : java.lang.Short
`implicit def` | short2double (x : Short) : Double
`implicit def` | short2float (x : Short) : Float
`implicit def` | short2int (x : Short) : Int
`implicit def` | short2long (x : Short) : Long
`implicit def` | shortWrapper (x : Short) : RichShort
`implicit def` | stringBuilderWrapper (x : StringBuilder) : RichStringBuilder
`implicit def` | stringWrapper (x : java.lang.String) : RichString
`implicit def` | tuple22ordered [A1, A2](x : (A1, A2))(`implicit` view$2 : (A1) => Ordered[A1], `implicit` view$3 : (A2) => Ordered[A2]) : Ordered[(A1, A2)]
`implicit def` | tuple32ordered [A1, A2, A3](x : (A1, A2, A3))(`implicit` view$4 : (A1) => Ordered[A1], `implicit` view$5 : (A2) => Ordered[A2], `implicit` view$6 : (A3) => Ordered[A3]) : Ordered[(A1, A2, A3)]
`implicit def` | tuple42ordered [A1, A2, A3, A4](x : (A1, A2, A3, A4))(`implicit` view$7 : (A1) => Ordered[A1], `implicit` view$8 : (A2) => Ordered[A2], `implicit` view$9 : (A3) => Ordered[A3], `implicit` view$10 : (A4) => Ordered[A4]) : Ordered[(A1, A2, A3, A4)]
`implicit def` | tuple52ordered [A1, A2, A3, A4, A5](x : (A1, A2, A3, A4, A5))(`implicit` view$11 : (A1) => Ordered[A1], `implicit` view$12 : (A2) => Ordered[A2], `implicit` view$13 : (A3) => Ordered[A3], `implicit` view$14 : (A4) => Ordered[A4], `implicit` view$15 : (A5) => Ordered[A5]) : Ordered[(A1, A2, A3, A4, A5)]
`implicit def` | tuple62ordered [A1, A2, A3, A4, A5, A6](x : (A1, A2, A3, A4, A5, A6))(`implicit` view$16 : (A1) => Ordered[A1], `implicit` view$17 : (A2) => Ordered[A2], `implicit` view$18 : (A3) => Ordered[A3], `implicit` view$19 : (A4) => Ordered[A4], `implicit` view$20 : (A5) => Ordered[A5], `implicit` view$21 : (A6) => Ordered[A6]) : Ordered[(A1, A2, A3, A4, A5, A6)]
`implicit def` | tuple72ordered [A1, A2, A3, A4, A5, A6, A7](x : (A1, A2, A3, A4, A5, A6, A7))(`implicit` view$22 : (A1) => Ordered[A1], `implicit` view$23 : (A2) => Ordered[A2], `implicit` view$24 : (A3) => Ordered[A3], `implicit` view$25 : (A4) => Ordered[A4], `implicit` view$26 : (A5) => Ordered[A5], `implicit` view$27 : (A6) => Ordered[A6], `implicit` view$28 : (A7) => Ordered[A7]) : Ordered[(A1, A2, A3, A4, A5, A6, A7)]
`implicit def` | tuple82ordered [A1, A2, A3, A4, A5, A6, A7, A8](x : (A1, A2, A3, A4, A5, A6, A7, A8))(`implicit` view$29 : (A1) => Ordered[A1], `implicit` view$30 : (A2) => Ordered[A2], `implicit` view$31 : (A3) => Ordered[A3], `implicit` view$32 : (A4) => Ordered[A4], `implicit` view$33 : (A5) => Ordered[A5], `implicit` view$34 : (A6) => Ordered[A6], `implicit` view$35 : (A7) => Ordered[A7], `implicit` view$36 : (A8) => Ordered[A8]) : Ordered[(A1, A2, A3, A4, A5, A6, A7, A8)]
`implicit def` | tuple92ordered [A1, A2, A3, A4, A5, A6, A7, A8, A9](x : (A1, A2, A3, A4, A5, A6, A7, A8, A9))(`implicit` view$37 : (A1) => Ordered[A1], `implicit` view$38 : (A2) => Ordered[A2], `implicit` view$39 : (A3) => Ordered[A3], `implicit` view$40 : (A4) => Ordered[A4], `implicit` view$41 : (A5) => Ordered[A5], `implicit` view$42 : (A6) => Ordered[A6], `implicit` view$43 : (A7) => Ordered[A7], `implicit` view$44 : (A8) => Ordered[A8], `implicit` view$45 : (A9) => Ordered[A9]) : Ordered[(A1, A2, A3, A4, A5, A6, A7, A8, A9)]
`implicit def` | unit2ordered (x : Unit) : Ordered[Unit]

Methods inherited from AnyRef
getClass, hashCode, equals, clone, toString, notify, notifyAll, wait, wait, wait, finalize, ==, !=, eq, ne, synchronized

Methods inherited from Any
==, !=, isInstanceOf, asInstanceOf

Class Summary
`class` | ArrowAssoc [A](x : A)`extends` AnyRef

Object Summary
`object` | Pair `extends` AnyRef
`object` | Triple `extends` AnyRef

Type Details

`` `type` byte

`` `type` short

`` `type` char

`` `type` int

`` `type` long

`` `type` float

`` `type` double

`` `type` boolean

`` `type` unit

@deprecated
`` `type` All

Deprecated
  use `Nothing` instead

@deprecated
`` `type` AllRef

Deprecated
  use `Null` instead

@deprecated
`` `type` Integer

Deprecated
  use `Int` instead

@deprecated
`` `type` Character

Deprecated
  use `Char` instead

`` `type` String

`` `type` StringBuilder

`` `type` Class

`` `type` Runnable

`` `type` Throwable

`` `type` Exception

`` `type` Error

`` `type` RuntimeException

`` `type` NullPointerException

`` `type` ClassCastException

`` `type` IndexOutOfBoundsException

`` `type` ArrayIndexOutOfBoundsException

`` `type` UnsupportedOperationException

`` `type` IllegalArgumentException

`` `type` NoSuchElementException

`` `type` NumberFormatException

`` `type` Function

`` `type` Map

`` `type` Set

`` `type` Pair

`` `type` Triple

Value Details

`` `val` Map : Map

`` `val` Set : Set

Method Details

`` `def` classOf[T] : java.lang.Class

  Return the runtime representation of a class type.

`` `def` error(message : java.lang.String) : Nothing

`` `def` exit : Nothing

`` `def` exit(status : Int) : Nothing

`` `def` assert(assertion : Boolean) : Unit

`` `def` assert(assertion : Boolean, message : Any) : Unit

`` `def` assume(assumption : Boolean) : Unit

`` `def` assume(assumption : Boolean, message : Any) : Unit

`implicit` `def` any2ArrowAssoc[A](x : A) : ArrowAssoc[A]

`` `def` Tuple[A1](x1 : A1) : (A1)

`` `def` Tuple[A1, A2](x1 : A1, x2 : A2) : (A1, A2)

`` `def` Tuple[A1, A2, A3](x1 : A1, x2 : A2, x3 : A3) : (A1, A2, A3)

`` `def` Tuple[A1, A2, A3, A4](x1 : A1, x2 : A2, x3 : A3, x4 : A4) : (A1, A2, A3, A4)

`` `def` Tuple[A1, A2, A3, A4, A5](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5) : (A1, A2, A3, A4, A5)

`` `def` Tuple[A1, A2, A3, A4, A5, A6](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6) : (A1, A2, A3, A4, A5, A6)

`` `def` Tuple[A1, A2, A3, A4, A5, A6, A7](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7) : (A1, A2, A3, A4, A5, A6, A7)

`` `def` Tuple[A1, A2, A3, A4, A5, A6, A7, A8](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7, x8 : A8) : (A1, A2, A3, A4, A5, A6, A7, A8)

`` `def` Tuple[A1, A2, A3, A4, A5, A6, A7, A8, A9](x1 : A1, x2 : A2, x3 : A3, x4 : A4, x5 : A5, x6 : A6, x7 : A7, x8 : A8, x9 : A9) : (A1, A2, A3, A4, A5, A6, A7, A8, A9)

`` `def` print(x : Any) : Unit

`` `def` println : Unit

`` `def` println(x : Any) : Unit

`` `def` printf(text : java.lang.String, xs : Any*) : Unit

`` `def` format(text : java.lang.String, xs : Any*) : Unit

`` `def` readLine : java.lang.String

`` `def` readLine(text : java.lang.String, args : Any*) : java.lang.String

`` `def` readBoolean : Boolean

`` `def` readByte : Byte

`` `def` readShort : Short

`` `def` readChar : Char

`` `def` readInt : Int

`` `def` readLong : Long

`` `def` readFloat : Float

`` `def` readDouble : Double

`` `def` readf(format : java.lang.String) : List[Any]

`` `def` readf1(format : java.lang.String) : Any

`` `def` readf2(format : java.lang.String) : (Any, Any)

`` `def` readf3(format : java.lang.String) : (Any, Any, Any)

`implicit` `def` identity[A](x : A) : A

`implicit` `def` byteWrapper(x : Byte) : RichByte

`implicit` `def` shortWrapper(x : Short) : RichShort

`implicit` `def` intWrapper(x : Int) : RichInt

`implicit` `def` charWrapper(c : Char) : RichChar

`implicit` `def` longWrapper(x : Long) : RichLong

`implicit` `def` floatWrapper(x : Float) : RichFloat

`implicit` `def` doubleWrapper(x : Double) : RichDouble

`implicit` `def` booleanWrapper(x : Boolean) : RichBoolean

`implicit` `def` stringWrapper(x : java.lang.String) : RichString

`implicit` `def` stringBuilderWrapper(x : StringBuilder) : RichStringBuilder

`implicit` `def` any2stringadd(x : Any) : StringAdd

`implicit` `def` exceptionWrapper(exc : java.lang.Throwable) : RichException

`implicit` `def` unit2ordered(x : Unit) : Ordered[Unit]

`implicit` `def` iterable2ordered[A](xs : Iterable[A])(`implicit` view$1 : (A) => Ordered[A]) : Ordered[Iterable[A]]

`implicit` `def` tuple22ordered[A1, A2](x : (A1, A2))(`implicit` view$2 : (A1) => Ordered[A1], `implicit` view$3 : (A2) => Ordered[A2]) : Ordered[(A1, A2)]

`implicit` `def` tuple32ordered[A1, A2, A3](x : (A1, A2, A3))(`implicit` view$4 : (A1) => Ordered[A1], `implicit` view$5 : (A2) => Ordered[A2], `implicit` view$6 : (A3) => Ordered[A3]) : Ordered[(A1, A2, A3)]

`implicit` `def` tuple42ordered[A1, A2, A3, A4](x : (A1, A2, A3, A4))(`implicit` view$7 : (A1) => Ordered[A1], `implicit` view$8 : (A2) => Ordered[A2], `implicit` view$9 : (A3) => Ordered[A3], `implicit` view$10 : (A4) => Ordered[A4]) : Ordered[(A1, A2, A3, A4)]

`implicit` `def` tuple52ordered[A1, A2, A3, A4, A5](x : (A1, A2, A3, A4, A5))(`implicit` view$11 : (A1) => Ordered[A1], `implicit` view$12 : (A2) => Ordered[A2], `implicit` view$13 : (A3) => Ordered[A3], `implicit` view$14 : (A4) => Ordered[A4], `implicit` view$15 : (A5) => Ordered[A5]) : Ordered[(A1, A2, A3, A4, A5)]

`implicit` `def` tuple62ordered[A1, A2, A3, A4, A5, A6](x : (A1, A2, A3, A4, A5, A6))(`implicit` view$16 : (A1) => Ordered[A1], `implicit` view$17 : (A2) => Ordered[A2], `implicit` view$18 : (A3) => Ordered[A3], `implicit` view$19 : (A4) => Ordered[A4], `implicit` view$20 : (A5) => Ordered[A5], `implicit` view$21 : (A6) => Ordered[A6]) : Ordered[(A1, A2, A3, A4, A5, A6)]

`implicit` `def` tuple72ordered[A1, A2, A3, A4, A5, A6, A7](x : (A1, A2, A3, A4, A5, A6, A7))(`implicit` view$22 : (A1) => Ordered[A1], `implicit` view$23 : (A2) => Ordered[A2], `implicit` view$24 : (A3) => Ordered[A3], `implicit` view$25 : (A4) => Ordered[A4], `implicit` view$26 : (A5) => Ordered[A5], `implicit` view$27 : (A6) => Ordered[A6], `implicit` view$28 : (A7) => Ordered[A7]) : Ordered[(A1, A2, A3, A4, A5, A6, A7)]

`implicit` `def` tuple82ordered[A1, A2, A3, A4, A5, A6, A7, A8](x : (A1, A2, A3, A4, A5, A6, A7, A8))(`implicit` view$29 : (A1) => Ordered[A1], `implicit` view$30 : (A2) => Ordered[A2], `implicit` view$31 : (A3) => Ordered[A3], `implicit` view$32 : (A4) => Ordered[A4], `implicit` view$33 : (A5) => Ordered[A5], `implicit` view$34 : (A6) => Ordered[A6], `implicit` view$35 : (A7) => Ordered[A7], `implicit` view$36 : (A8) => Ordered[A8]) : Ordered[(A1, A2, A3, A4, A5, A6, A7, A8)]

`implicit` `def` tuple92ordered[A1, A2, A3, A4, A5, A6, A7, A8, A9](x : (A1, A2, A3, A4, A5, A6, A7, A8, A9))(`implicit` view$37 : (A1) => Ordered[A1], `implicit` view$38 : (A2) => Ordered[A2], `implicit` view$39 : (A3) => Ordered[A3], `implicit` view$40 : (A4) => Ordered[A4], `implicit` view$41 : (A5) => Ordered[A5], `implicit` view$42 : (A6) => Ordered[A6], `implicit` view$43 : (A7) => Ordered[A7], `implicit` view$44 : (A8) => Ordered[A8], `implicit` view$45 : (A9) => Ordered[A9]) : Ordered[(A1, A2, A3, A4, A5, A6, A7, A8, A9)]

`implicit` `def` byte2short(x : Byte) : Short

`implicit` `def` byte2int(x : Byte) : Int

`implicit` `def` byte2long(x : Byte) : Long

`implicit` `def` byte2float(x : Byte) : Float

`implicit` `def` byte2double(x : Byte) : Double

`implicit` `def` short2int(x : Short) : Int

`implicit` `def` short2long(x : Short) : Long

`implicit` `def` short2float(x : Short) : Float

`implicit` `def` short2double(x : Short) : Double

`implicit` `def` char2int(x : Char) : Int

`implicit` `def` char2long(x : Char) : Long

`implicit` `def` char2float(x : Char) : Float

`implicit` `def` char2double(x : Char) : Double

`implicit` `def` int2long(x : Int) : Long

`implicit` `def` int2float(x : Int) : Float

`implicit` `def` int2double(x : Int) : Double

`implicit` `def` long2float(x : Long) : Float

`implicit` `def` long2double(x : Long) : Double

`implicit` `def` float2double(x : Float) : Double

`implicit` `def` byte2Byte(x : Byte) : java.lang.Byte

`implicit` `def` short2Short(x : Short) : java.lang.Short

`implicit` `def` char2Character(x : Char) : java.lang.Character

`implicit` `def` int2Integer(x : Int) : java.lang.Integer

`implicit` `def` long2Long(x : Long) : java.lang.Long

`implicit` `def` float2Float(x : Float) : java.lang.Float

`implicit` `def` double2Double(x : Double) : java.lang.Double

`implicit` `def` boolean2Boolean(x : Boolean) : java.lang.Boolean

`implicit` `def` forceArrayProjection[A](x : Projection[A]) : Array[A]

  any array projection can be automatically converted into an array

`implicit` `def` forceRandomAccessCharSeq(x : RichString) : java.lang.String

  any random access character seq (including rich string can be converted into a string

`` `def` currentThread : java.lang.Thread